/************************************************************************
 *
 * Copyright (C) 2017 IRCAD France
 * Copyright (C) 2017 IHU Strasbourg
 *
 * This file is part of Sight.
 *
 * Sight is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Sight is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Sight. If not, see <https://www.gnu.org/licenses/>.
 *
 ***********************************************************************/

#ifndef __FWSTRUCTURALPATCH_CONFIG_HPP__
#define __FWSTRUCTURALPATCH_CONFIG_HPP__

    #ifdef _WIN32

        #ifdef FWSTRUCTURALPATCH_EXPORTS
            #define FWSTRUCTURALPATCH_API __declspec(dllexport)
            #define FWSTRUCTURALPATCH_CLASS_QT_API __declspec(dllexport)
        #else
            #define FWSTRUCTURALPATCH_API __declspec(dllimport)
            #define FWSTRUCTURALPATCH_CLASS_QT_API __declspec(dllimport)
        #endif

        #define FWSTRUCTURALPATCH_CLASS_API
        #define FWSTRUCTURALPATCH_DEPRECATED_CLASS_API [[deprecated]]
        #define FWSTRUCTURALPATCH_QT_API

        #pragma warning(disable: 4290)

    #elif defined(__GNUC__) && (__GNUC__>=4)

        #define FWSTRUCTURALPATCH_API __attribute__ ((visibility("default")))
        #define FWSTRUCTURALPATCH_CLASS_API __attribute__ ((visibility("default")))
        #define FWSTRUCTURALPATCH_DEPRECATED_CLASS_API __attribute__ ((visibility("default"))) __attribute__((deprecated))

        #define FWSTRUCTURALPATCH_QT_API __attribute__ ((visibility("default")))
        #define FWSTRUCTURALPATCH_CLASS_QT_API __attribute__ ((visibility("default")))

    #else

        #define FWSTRUCTURALPATCH_API
        #define FWSTRUCTURALPATCH_CLASS_API
        #define FWSTRUCTURALPATCH__DEPRECATED_CLASS_API
        #define FWSTRUCTURALPATCH_QT_API
        #define FWSTRUCTURALPATCH_CLASS_QT_API

    #endif

#endif // __FWSTRUCTURALPATCH_CONFIG_HPP__
